// PSF_AccessDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PSF_Access.h"
#include "PSF_AccessDlg.h"
#include "IF60_API.h"
#include "SerialPort.h"
#include "ni488.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

	IF60_API	IF_60US ;
	SerialPort	IF_60RS ;

/////////////////////////////////////////////////////////////////////////////
// CPSF_AccessDlg _CAO

CPSF_AccessDlg::CPSF_AccessDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPSF_AccessDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPSF_AccessDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CPSF_AccessDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPSF_AccessDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPSF_AccessDlg, CDialog)
	//{{AFX_MSG_MAP(CPSF_AccessDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON7, OnOpenDevice)
	ON_BN_CLICKED(IDC_BUTTON6, OnOutput)
	ON_BN_CLICKED(IDC_BUTTON5, OnPreset1)
	ON_BN_CLICKED(IDC_BUTTON4, OnPreset2)
	ON_BN_CLICKED(IDC_BUTTON3, OnPreset3)
	ON_BN_CLICKED(IDC_BUTTON2, OnPresetOff)
	ON_BN_CLICKED(IDC_BUTTON1, OnReadMonitor)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPSF_AccessDlg bZ[W nh

BOOL CPSF_AccessDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	Result0 = IF_60US.IFInitialize();	/*@`oh֐nh̏@*/

	//R{{bNXݒ
	CComboBox *cbx0,*cbx1,*cbx2;
	CButton *cbt1,*cbt2,*cbt3,*cbt4,*cbt5,*cbt6,*cbt7;
	int index0 ; 
	char buf[5];
		
	cbx0=(CComboBox*)GetDlgItem(IDC_COMBO1);
	cbx1=(CComboBox*)GetDlgItem(IDC_COMBO2);
	cbx2=(CComboBox*)GetDlgItem(IDC_COMBO3);
	cbt1=(CButton*)GetDlgItem(IDC_BUTTON7);
	cbt2=(CButton*)GetDlgItem(IDC_BUTTON2);
	cbt3=(CButton*)GetDlgItem(IDC_BUTTON3);
	cbt4=(CButton*)GetDlgItem(IDC_BUTTON4);
	cbt5=(CButton*)GetDlgItem(IDC_BUTTON5);
	cbt6=(CButton*)GetDlgItem(IDC_BUTTON6);
	cbt7=(CButton*)GetDlgItem(IDC_BUTTON1);
	
	cbx0->AddString("GPIB0");
	cbx0->AddString("COM");

	for (index0 = 1 ; index0 < 31 ; index0 ++)
	{
		_itoa(index0 , buf , 10);
		cbx1->AddString(buf);
		cbx2->AddString(buf);		
	}

	cbx0->SelectString (-1 , "GPIB0");
	cbx1->SelectString (-1 , "1");
	cbx2->SelectString (-1 , "1");

	cbt2->EnableWindow(FALSE);
	cbt3->EnableWindow(FALSE);
	cbt4->EnableWindow(FALSE);
	cbt5->EnableWindow(FALSE);
	cbt6->EnableWindow(FALSE);
	cbt7->EnableWindow(FALSE);	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CPSF_AccessDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CPSF_AccessDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPSF_AccessDlg::OnOpenDevice() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CComboBox *cbx0,*cbx1,*cbx2;
	CButton *cbt1,*cbt2,*cbt3,*cbt4,*cbt5,*cbt6,*cbt7;
	CEdit *ced1;

	char buf[10];
	char buf_open[] = "OPEN" ;
	
	cbx0=(CComboBox*)GetDlgItem(IDC_COMBO1);
	cbx1=(CComboBox*)GetDlgItem(IDC_COMBO2);
	cbx2=(CComboBox*)GetDlgItem(IDC_COMBO3);

	cbt1=(CButton*)GetDlgItem(IDC_BUTTON1);
	cbt2=(CButton*)GetDlgItem(IDC_BUTTON2);
	cbt3=(CButton*)GetDlgItem(IDC_BUTTON3);
	cbt4=(CButton*)GetDlgItem(IDC_BUTTON4);
	cbt5=(CButton*)GetDlgItem(IDC_BUTTON5);
	cbt6=(CButton*)GetDlgItem(IDC_BUTTON6);
	cbt7=(CButton*)GetDlgItem(IDC_BUTTON7);
	ced1=(CEdit*)GetDlgItem(IDC_EDIT1);
	
	cbt7->GetWindowText (buf , 10) ;
	if ( strcmp( buf , buf_open) == 0){
		cbx1->GetWindowText (buf , 10) ;	//PC ADDR read
		Pc_Addr = atoi(buf);
		cbx2->GetWindowText (buf , 10) ;	//SYS ADDR read
		Sys_Addr = atoi(buf);
		cbx0->GetWindowText (buf , 10) ;	//IF read
		if( strcmp( "GPIB0" , buf) == 0){
			IF_name = 1;
		}
		else if( strcmp( "COM" , buf) == 0){
			IF_name = 2;
		}

		DeviceId = OpenDev(IF_name , Pc_Addr ,Sys_Addr);
		if (DeviceId < 0){
			ced1->SetWindowText("Device Open Error");
			return ;
		}
		Result0 = SendMsg( Pc_Addr,":OUTP 0\n" );

		cbt7->SetWindowText ("CLOSE");
		cbt2->EnableWindow(TRUE);
		cbt3->EnableWindow(TRUE);
		cbt4->EnableWindow(TRUE);
		cbt5->EnableWindow(TRUE);
		cbt6->EnableWindow(TRUE);
		cbt1->EnableWindow(TRUE);
		ced1->SetWindowText("");
	}
	else
	{
		Result0 = SendMsg(Pc_Addr,":OUTP 0\n" );
		Result0 = SendMsg(Pc_Addr,":ADDR 1\n" );
		Result0 = SendMsg(Pc_Addr,":Remote 0\n" );
		Result0 = CloseDev(Pc_Addr);
		cbt7->SetWindowText ("OPEN");
		cbt2->EnableWindow(FALSE);
		cbt3->EnableWindow(FALSE);
		cbt4->EnableWindow(FALSE);
		cbt5->EnableWindow(FALSE);
		cbt6->EnableWindow(FALSE);
		cbt1->EnableWindow(FALSE);
		cbt6->SetWindowText("ON");
		ced1->SetWindowText("");
		DeviceId = 0 ;
	}	
}

void CPSF_AccessDlg::OnOutput() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton *cbt2;
	char buf[10];
	char buf_on[] = "ON" ;
	
	cbt2=(CButton*)GetDlgItem(IDC_BUTTON6);
	cbt2->GetWindowText (buf , 10) ;
	if ( strcmp( buf , buf_on) == 0){	// OFF -> ON
		cbt2->SetWindowText ("OFF");
		Result0 = SendMsg(Pc_Addr,":OUTP 1\n" );
	}
	else								// ON -> OFF
	{
		cbt2->SetWindowText ("ON");
		Result0 = SendMsg(Pc_Addr,":OUTP 0\n" );
	}		
}

void CPSF_AccessDlg::OnReadMonitor() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CEdit *ced1;
	char MonitorMsg[64];
	double MonData[4];
	int count , count1 ,index; 

	ced1=(CEdit*)GetDlgItem(IDC_EDIT1);

	Result0 = SendMsg(Pc_Addr,":meas?\n" );
	Sleep(200);
	Result0 = ReadMsg(Pc_Addr ,64 ,MonitorMsg);
	count = 1 ;
	count1 = 0 ;
	MonData[0] = atof(&MonitorMsg[0]);			// P1
	for (index = 0 ;index < 64 ; index ++){
		if( MonitorMsg[index] == ','){
			count1 = index ; 
			MonData[count] = atof(&MonitorMsg[count1+1]);
			count ++;
			if (count > 4 ) break; 
		}
	}
	count1 = index ; 
	MonData[count] = atof(&MonitorMsg[count1+1]);
	sprintf(MonitorMsg,"Volt : %4.2f \r\nCurr : %4.2f \r\nWatt : %4.2f \r\nCVCC: %1.0f",MonData[0],MonData[1],MonData[2],MonData[3]);
	ced1->SetWindowText(MonitorMsg);

}
void CPSF_AccessDlg::OnPreset1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		Result0 = SendMsg(Pc_Addr,":pres:call 1\n" );
}

void CPSF_AccessDlg::OnPreset2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		Result0 = SendMsg(Pc_Addr,":pres:call 2\n" );
}

void CPSF_AccessDlg::OnPreset3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		Result0 = SendMsg(Pc_Addr,":pres:call 3\n" );	
}

void CPSF_AccessDlg::OnPresetOff() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		Result0 = SendMsg(Pc_Addr,":pres:call 0\n" );
}


// Interface Select
long CPSF_AccessDlg::OpenDev( int if_name , int addrs ,int lcaddr)
{
	char LocalAd[20] ;

	sprintf( LocalAd , ":ADDR %d\n",lcaddr) ;
	switch(if_name){
	case IF_GPIB :	//GPIB
		DeviceId = ibdev( 0,addrs, 0, T1s, 1, 0x1C0A );
		
		break;
	case IF_COM : //COM
		DeviceHandle = IF_60RS.COM_OpenDevice (addrs);
		if (DeviceHandle == (HANDLE) -1 ){
			DeviceId = -1;
		}
		else{
			DeviceId = addrs ;
		}
		break;
	}
	if (DeviceId < 0 ){
		return -1;
	}
	SendMsg (addrs , LocalAd);

	return DeviceId ;
}

int CPSF_AccessDlg::CloseDev(int addrs)
{
	switch(IF_name){
	case IF_GPIB :	//GPIB
		Result0 = ibloc(DeviceId);
		Result0 = ibonl(DeviceId,0);
		break;

	case IF_COM : //COM
		Result0 = IF_60RS.COM_CloseDevice (DeviceHandle);
		break;
	}		
	return Result0 ;
}

int CPSF_AccessDlg::SendMsg(int addrs , char *cMsg)
{
	int iLength ;
	
	iLength = strlen(cMsg);
	switch(IF_name){
	case IF_GPIB :	//GPIB
		Result0 = ibwrt(DeviceId , cMsg , iLength);
		break;

	case IF_COM : //COM
		if (IF_60RS.COM_Send (DeviceHandle , cMsg , iLength) == 0)
			Result0 = iLength ;
		else 
			Result0 = -1;
		break;
	}		
	return Result0 ;
}

int CPSF_AccessDlg::ReadMsg(int addrs , int count, char *cMsg)
{
	switch(IF_name){
	case IF_GPIB :	//GPIB
		Result0 = ibrd(DeviceId, cMsg , count);
		Result0 = ibcnt ;
		break;

	case IF_COM : //COM
		Result0 = IF_60RS.COM_Receive (DeviceHandle , cMsg);
		break;
	}		
	return 0 ;
}

void CPSF_AccessDlg::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if (DeviceId != 0){				//Device Opened
		Result0 = SendMsg(Pc_Addr,":OUTP 0\n" );
		Result0 = SendMsg(Pc_Addr,":ADDR 1\n" );
		Result0 = SendMsg(Pc_Addr,":Remote 0\n" );
		Result0 = CloseDev(Pc_Addr);
	}
	CDialog::OnClose();
}
